<script lang="ts">
  import { fade } from "svelte/transition";
  import {
    canClickCard,
    createActionDispatcher,
    createCardAction,
    isThinking,
  } from "./actionUtils";
  import CardBack from "./card/CardBack.svelte";
  import CardFan from "./card/CardFan.svelte";
  import CardFront from "./card/CardFront.svelte";
  import { max, rankTitle } from "./card/cardUtils";
  import { receive, send } from "./card/crossfade";
  import Deck from "./card/Deck.svelte";
  import PlayerScore from "./PlayerScore.svelte";
  import RoundSummary from "./RoundSummary.svelte";
  import { getRank, getSuit } from "./serverUtils";
  import TrickSummary from "./TrickSummary.svelte";

  const dispatchAction = createActionDispatcher();

  export let playerId: PlayerId | undefined;
  export let state: GameState;
  export let settings: GameSettings;

  $: players = state.players;
  $: phase = state.phase;
  $: user = state.players.find((p) => p.id === playerId) ?? null;

  $: player = players.find((p: Player) => p.id === playerId) || players[0];
  $: otherPlayer = players.filter((p) => p.id !== player.id)[0];

  function cardClickable(
    state: GameState,
    player: Player
  ): (c: Card) => boolean {
    return (card: Card) => {
      switch (state.phase.t) {
        case "Lead":
          return true;
        case "Follow": {
          const ledCard = state.played_cards[0];
          const suit = getSuit(ledCard);
          const highestOfSuit = max(player.hand, suit);

          if (highestOfSuit === undefined) {
            return true; // player can't follow suit, and can play any card
          } else if (getRank(ledCard) === "11") {
            return (
              getSuit(card) === suit &&
              (getRank(card) === "1" || card === highestOfSuit)
            );
          } else {
            return getSuit(card) === suit;
          }
        }
        default:
          return true;
      }
    };
  }
</script>

<div class="wrapper">
  <div class="other-player-wrapper">
    <div class="other-player-outer">
      <div class="other-player-inner">
        <div class="taken-cards">
          {#each otherPlayer.taken as card (card)}
            <div class="taken-card">
              <div in:receive={{ key: card }}>
                <CardBack />
              </div>
            </div>
          {/each}
        </div>
        <div class="cards">
          <CardFan facedown cards={otherPlayer.hand} />
        </div>
        <gs6-player-box
          playerid={otherPlayer.id}
          thinking={isThinking(state.phase, otherPlayer.id)}
        >
          <div class="player-box-content">
            <PlayerScore player={otherPlayer} />
          </div>
        </gs6-player-box>
      </div>
    </div>
  </div>
  <div class="center">
    <div class="decree">
      {#each [state.decree] as card (card)}
        <div class="decree-inner">
          <div in:receive={{ key: card }} out:send={{ key: card }}>
            <CardFront {card} />
          </div>
        </div>
      {/each}
    </div>
    <div class="deck">
      <div class="deck-inner">
        <Deck deck={state.deck} />
      </div>
    </div>
    <div class="played-cards">
      {#each state.played_cards as card (card)}
        <div>
          <div in:receive={{ key: card }} out:send={{ key: card }}>
            <CardFront {card} />
          </div>
        </div>
      {/each}
    </div>
  </div>
  <div class="player-wrapper" class:user={player.id === playerId}>
    <div class="player-outer">
      <div class="player-inner">
        <div class="taken-cards">
          {#each player.taken as card (card)}
            <div class="taken-card">
              <div in:receive={{ key: card }}>
                <CardBack />
              </div>
            </div>
          {/each}
        </div>
        <div class="cards">
          <CardFan
            facedown={player.id !== playerId}
            cards={player.hand}
            active={canClickCard(state.phase, player.id)}
            clickable={cardClickable(state, player)}
            on:click={(event) => {
              const action = createCardAction(state.phase, event.detail.idx);
              if (action !== null) {
                dispatchAction(action);
              }
            }}
          />
        </div>
        <gs6-player-box
          playerid={player.id}
          thinking={isThinking(state.phase, player.id)}
        >
          <div class="player-box-content">
            <PlayerScore {player} />
          </div>
        </gs6-player-box>
      </div>
    </div>
  </div>

  {#if state.phase.t === "TrickComplete"}
    <div class="info-wrapper">
      <div class="info-outer">
        <div class="info panel" transition:fade={{ duration: 150 }}>
          <TrickSummary
            {user}
            summary={state.phase}
            on:click={() => dispatchAction({ t: "Ready" })}
          />
        </div>
      </div>
    </div>
  {:else if state.phase.t === "RoundComplete"}
    <div class="info-wrapper">
      <div class="info-outer">
        <div class="info panel" transition:fade={{ duration: 150 }}>
          <RoundSummary
            {user}
            {state}
            on:click={() => dispatchAction({ t: "Ready" })}
          />
        </div>
      </div>
    </div>
  {:else if isThinking(state.phase, player.id) && state.phase.t === "Exchanging"}
    <div class="info-wrapper">
      <div class="info-outer">
        <div
          class="info info-exchange panel"
          transition:fade={{ duration: 150 }}
        >
          <span>
            <strong>{rankTitle("3")}:</strong>
            <em>Select card to exchange with the trump card.</em>
          </span>
          <div class="info-exchange-button-wrapper">
            <button
              class="small primary"
              on:click={() => dispatchAction({ t: "Exchange", idx: null })}
            >
              Skip
            </button>
          </div>
        </div>
      </div>
    </div>
  {:else if isThinking(state.phase, player.id) && state.phase.t === "Discarding"}
    <div class="info-wrapper">
      <div class="info-outer">
        <div class="info panel" transition:fade={{ duration: 150 }}>
          <span>
            <strong>{rankTitle("5")}:</strong> You drew
            <CardFront inline card={state.phase.drawn_card} />.
          </span>
          <br />
          <em>Select card to discard to the bottom of the deck.</em>
        </div>
      </div>
    </div>
  {/if}

  {#if phase.t === "GameComplete"}
    <div class="panel game-complete">
      <h3>
        <gs6-user playerid={phase.winner} />
        wins!
      </h3>
      {#if players.every((p) => p.score === players[0].score) && phase.t === "GameComplete"}
        <p>
          <small>
            Even though both players ended up with the same score,
            <gs6-user playerid={phase.winner} />
            won the most tricks in the last round.
          </small>
        </p>
      {:else if players.every((p) => p.score >= settings.goal) && phase.t === "GameComplete"}
        <p>
          <small>
            Even though both players reached the goal,
            <gs6-user playerid={phase.winner} />
            ended up with the highest score.
          </small>
        </p>
      {/if}
    </div>
  {/if}
</div>

<style>
  @import url("https://fonts.googleapis.com/css2?family=Domine&family=PT+Sans+Narrow&display=swap");

  .wrapper {
    --card-height: 14em;
    --card-width: 10em;
  }
  .other-player-wrapper {
    position: absolute;
    left: 50%;
    top: 50%;
    transform: translate(-50%, -50%) translateY(-10rem);
  }

  .other-player-outer {
    position: relative;
  }

  .other-player-inner {
    position: absolute;
    bottom: 0;
    left: 50%;
    transform: translateX(-50%);
  }

  .cards {
    height: var(--card-height);
    width: var(--card-width);
  }
  .other-player-inner .cards {
    font-size: 0.75em;
    position: absolute;
    left: 50%;
    top: 0;
    transform: translate(-50%, -67%);
  }

  .taken-card {
    font-size: 15%;
    position: absolute;
    z-index: -999;
    bottom: 0.5rem;
    left: calc(50% + 0.5rem);
  }

  .center {
    font-size: 0.75em;

    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);

    display: grid;
    grid-template-columns: 1fr 1fr auto;
    place-content: center;
  }
  .deck,
  .decree,
  .played-cards {
    margin: 0 1em;
  }

  .decree,
  .deck {
    position: relative;
    height: var(--card-height);
    width: var(--card-width);
  }

  .decree-inner,
  .deck-inner {
    position: absolute;
  }

  .played-cards {
    width: 20em;
    position: relative;
    height: 14em;
  }
  .played-cards > * {
    position: absolute;
    top: 0;
    left: 50%;
  }
  .played-cards > *:first-child {
    transform: translateX(-60%) rotate(-10deg);
  }
  .played-cards > *:not(:first-child) {
    transform: translateX(-40%) rotate(10deg);
  }
  .player-box-content {
    display: grid;
    place-content: center;
  }

  .info-wrapper {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
  }

  .info-outer {
    position: relative;
    height: var(--card-height);
    width: calc(var(--card-width) * 4);
  }

  .info {
    font-size: 1rem;

    position: absolute;
    bottom: 0;
    left: 50%;
    transform: translate(-50%, 0);
  }

  .info-exchange {
    display: grid;
    grid-template-rows: auto 1rem;
    align-items: end;
  }

  .info-exchange-button-wrapper {
    text-align: right;
  }
  .info-exchange button {
    width: 5rem;
  }

  .info strong {
    font-weight: 500;
  }
  .info em {
    font-style: italic;
    font-weight: 300;
  }

  .player-wrapper {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%) translateY(26rem);
  }

  .player-outer {
    position: relative;
  }
  .player-inner {
    position: absolute;
    bottom: 0;
    left: 50%;
    transform: translateX(-50%);
  }

  .player-inner .cards {
    font-size: 0.75em;
    position: absolute;
    left: 50%;
    top: 0;
    transform: translate(-50%, -67%);
  }

  .user .cards {
    font-size: 1rem;
  }

  .game-complete {
    position: absolute;
    left: 50%;
    top: 50%;
    transform: translate(-50%, -50%);

    display: flex;
    flex-direction: column;
    align-items: center;
    padding: 2em;
  }
</style>
